=== modified file 'lib/lp/soyuz/browser/tests/test_archive_webservice.py'
--- lib/lp/soyuz/browser/tests/test_archive_webservice.py	2011-06-06 14:27:47 +0000
+++ lib/lp/soyuz/browser/tests/test_archive_webservice.py	2011-06-13 18:23:08 +0000
@@ -156,6 +156,21 @@
             dependency=ws_dependency, pocket='Release', component='main')
         self.assertContentEqual([dependency], ws_archive.dependencies)
 
+    def test_addArchiveDependency_invalid(self):
+        """Invalid requests generate a BadRequest error."""
+        archive = self.factory.makeArchive()
+        dependency = self.factory.makeArchive()
+        with person_logged_in(archive.owner):
+            archive.addArchiveDependency(
+                dependency, PackagePublishingPocket.RELEASE)
+        transaction.commit()
+        ws_archive = self.wsObject(archive, archive.owner)
+        ws_dependency = self.wsObject(dependency)
+        expected_re = '(.|\n)*This dependency is already registered(.|\n)*'
+        with ExpectedException(BadRequest, expected_re):
+            ws_archive.addArchiveDependency(
+                dependency=ws_dependency, pocket='Release')
+
     def test_removeArchiveDependency_random_user(self):
         """Normal users can remove archive dependencies."""
         archive = self.factory.makeArchive()

=== modified file 'lib/lp/soyuz/interfaces/archive.py'
--- lib/lp/soyuz/interfaces/archive.py	2011-06-11 00:49:33 +0000
+++ lib/lp/soyuz/interfaces/archive.py	2011-06-13 17:41:29 +0000
@@ -113,6 +113,7 @@
      * It is not a PPA,
      * It is already recorded.
     """
+    webservice_error(400)  # Bad request.
 
 
 # Exceptions used in the webservice that need to be in this file to get

